#define WIN32_LEAN_AND_MEAN
#define UNICODE
#include <windows.h>

#define DefWinStaDesk L"WinSta0\\Default"

extern "C" __declspec(dllexport)
DWORD WINAPI CreateProcessAsSYSTEMW(DWORD CallerPID, LPWSTR lpCommandLineW,
             DWORD dwCreationFlags, LPWSTR lpWinStaDeskW, LPWSTR lpCurrentDirectoryW) {
  HANDLE hCaller, hThread = NULL, hProcess = NULL;
  if(hCaller = OpenProcess(PROCESS_VM_READ | PROCESS_DUP_HANDLE, FALSE, CallerPID)) {
    WCHAR CLW[MAX_PATH];
    if(ReadProcessMemory(hCaller, lpCommandLineW, CLW, MAX_PATH*sizeof(WCHAR), NULL)) {
      WCHAR WDW[MAX_PATH] = DefWinStaDesk;
      if(lpWinStaDeskW)
        ReadProcessMemory(hCaller, lpWinStaDeskW, WDW, MAX_PATH*sizeof(WCHAR), NULL);
      WCHAR OldDIR[MAX_PATH]; OldDIR[0] = '\0';
      WCHAR NewDIR[MAX_PATH]; NewDIR[0] = '\0';
      if(GetCurrentDirectoryW(sizeof(OldDIR), OldDIR))
        if(lpCurrentDirectoryW)
          if(ReadProcessMemory(hCaller, lpCurrentDirectoryW, NewDIR, MAX_PATH*sizeof(WCHAR), NULL))
            SetCurrentDirectoryW(NewDIR);
      STARTUPINFOW si = {sizeof(si)}; //zeroes other members too
      si.lpDesktop = WDW;
      PROCESS_INFORMATION pi;
      if(CreateProcessW(NULL, CLW, NULL, NULL, FALSE, dwCreationFlags, NULL, NULL, &si, &pi)) {
        HANDLE hCP = GetCurrentProcess();
        DuplicateHandle(hCP, pi.hThread,  hCaller, &hThread,  0, FALSE, DUPLICATE_CLOSE_SOURCE | DUPLICATE_SAME_ACCESS);
        DuplicateHandle(hCP, pi.hProcess, hCaller, &hProcess, 0, FALSE, DUPLICATE_CLOSE_SOURCE | DUPLICATE_SAME_ACCESS);
      }
      if(OldDIR[0] && NewDIR[0])
        SetCurrentDirectoryW(OldDIR);
    }
    CloseHandle(hCaller);
  }
  return((LOWORD((DWORD)hProcess) << 16) + LOWORD((DWORD)hThread));
}