/////////////////////////////////////////////////////////
LPCTSTR AHExtErr2String(DWORD AHerr, DWORD RCpfl) {
  LPCTSTR SubError;

  switch(AHerr) {

    case ErrorAHOpen : 
           if(RCpfl & RC_PF_16TERM) {
             SubError = _T("(16bit and/or terminating)");
             break;
           }
           if(RCpfl & RC_PF_NOOPEN) {
             SubError = _T("(invalid PID or security(QR))");
             break;
           }
           SubError = _T("(invalid PID or security(QRWOTC))");
           break;

    case ErrorAHPrepare : 
           if(RCpfl & RC_PF_NATIVE) {
             SubError = _T("(native process)");
             break;
           }
           SubError = _T("(no memory)");
           break;

    case ErrorAHRemote : 
           if(RCpfl & RC_PF_NATIVE) {
             SubError = _T("(native process)");
             break;
           }
           SubError = _T("(can't load hooks or unexpected remote exception)");
           break;

    default:
           SubError = _T("");
  }
  return(SubError);
}
/////////////////////////////////////////////////////////